package dbc.r15.sample.dcjdbpr;

import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.text.NumberFormat;

import com.ibm.cics.server.Task;

public class DCJDBPR {
	static String headingOne = "                    EMPLOYEES IN THE STATE OF TEXAS                         ";
	static String headingTwo = "CITY               NAME                            TOTAL COMP             TAXES ";
	
		// User Id Block container name.
	static final String userIdBlock	  = "DCJDBPR DB/CICS 15.0 SAMPLE JDBC program";  
	public static void main(String[] args) throws ClassNotFoundException,
			SQLException, IOException {
		//Initiate the wrapper class for print
		PrintLineWrapper plw = new PrintLineWrapper();
		// define byte array for PRINT LINE 
		String sName, sCity, sWages, sCommission, sTaxes; 
		byte b80 [] = new byte [80];
		for (int i = 0; i < 80; i++) {
		b80[i] = (byte)0x40;
		}
		// Create an output data stream
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		BufferedOutputStream bos = new BufferedOutputStream(baos);
		DataOutputStream dos = new DataOutputStream(bos);
		 
		Class.forName("ca.datacom.jdbc.DatacomJdbcDriver");
		Task t = Task.getTask();
		
		String jdbcURL = "jdbc:datacom://USILCA11:6969/ServerName=SRVR14_15JDBC,ApplicationID=SRVR14_15JDBC,ConnectType=TCP";
		
		Connection conn = DriverManager.getConnection(jdbcURL);

		//t.out.println("Created Connection");
		 
		int pi = 0;
		dos.write(headingOne.getBytes());  // heading line 1
		plw.setByteArray(b80);
		dos.write(plw.getByteArray());     // blank line
		dos.write(headingTwo.getBytes());  // heading line 2
		plw.setBuffer(" ");
		dos.write(plw.getByteArray());     // blank line
		pi = 4;                  		   // up the index to 4 lines	
										   // Code Decimal formatting here
		NumberFormat nft = new DecimalFormat("###,###.00");   // tax format
		NumberFormat nfc = new DecimalFormat("#,###,###.00"); // compensation format
		double d = 0, dd = 0, dw = 0, dc = 0;
		double tt = 0, tc = 0;  // total tax, total compensation
		 
		String sqlquery = "SELECT PERSONNEL.NAME, PERSONNEL.CITY_ADDRESS AS CITY, " + 
			"PAYROLL.YTD_WAGES AS WAGES, PAYROLL.YTD_COMMISSION AS COMMISSION, PAYROLL.YTD_TAX AS TAXES " + 
				"FROM SYSUSR.PAYROLL, SYSUSR.PERSONNEL WHERE (PAYROLL.NUMBER = PERSONNEL.NUMBER) " +
			    "AND PERSONNEL.CITY_ADDRESS = 'DALLAS' AND PAYROLL.ACTIVITY_CODE = 'A'";
		

		Statement stmt = conn.createStatement();
		ResultSet rs = stmt.executeQuery(sqlquery);
		 
// Only process the first 21 rows of the sample data so that it can fit on the 3270 screen display 		
		while ( rs.next() & pi < 22)
		{ sName = rs.getString(1); sCity = rs.getString(2); 
		  sWages = rs.getString(3); sCommission = rs.getString(4); sTaxes = rs.getString(5);
		  plw.setBuffer(" ");
		  plw.setCity(sCity);
		  plw.setName(sName);
		  dc = Double.valueOf(sCommission);
		  dw = Double.valueOf(sWages);
		  dd = dc + dw;
		  tc += dd;						// total compensation
		  plw.setPay(nfc.format(dd));
		  d = Double.valueOf(sTaxes);
		  tt += d;						// total taxes
		  plw.setTaxes(nft.format(d));
		  dos.write(plw.getByteArray());
		  pi++;
		}
		plw.setBuffer(" ");				 // print a blank line
		dos.write(plw.getByteArray());
		plw.setPay(nfc.format(tc)); 	 // total compensation
		plw.setTaxes(nft.format(tt));	 // total tax
		plw.setCity("TOTALS");
		plw.setName("                        ");
		dos.write(plw.getByteArray());
		dos.flush();
		plw.setByteArray(baos.toByteArray());
		t.out.println(plw.getBuffer());  // Display the full screen
		baos.reset();
	}
}
